import 'package:flutter/material.dart';

///指示器
// ignore: must_be_immutable
class IndicatorView extends StatefulWidget {
  int count;
  int selectIndex;

  PageController pageController;

  IndicatorView(
      {Key key, this.count = 0, this.selectIndex = 0, this.pageController})
      : super(key: key);

  @override
  _IndicatorViewState createState() => _IndicatorViewState();
}

class _IndicatorViewState extends State<IndicatorView> {
  /// 普通的颜色
  final Color _normalColor = Color(0x66A1A1A1);

  /// 选中的颜色
  final Color _selectedColor = Color(0xFFA1A1A1);

  /// 点的大小
  final double size = 7.0;

  /// 点的间距
  final double spacing = 9.0;

  @override
  void initState() {
    super.initState();

    widget.pageController.addListener(() {
      int index = (widget.pageController.page + 0.1).toInt();
      if (widget.selectIndex != index) {
        widget.selectIndex = index;
        setState(() {});
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.center,
      children: _buildPoints(context),
    );
  }

  List<Widget> _buildPoints(BuildContext context) {
    List<Widget> items = [];
    for (var i = 0; i < widget.count; i++) {
      items.add(Container(
        margin: EdgeInsets.only(left: i == 0 ? 0 : spacing),
        height: size,
        width: size,
        decoration: BoxDecoration(
            shape: BoxShape.circle,
            color: i == widget.selectIndex ? _selectedColor : _normalColor),
      ));
    }
    return items;
  }
}
