import 'dart:math';

import 'package:flutter/material.dart';

class LedView extends CustomPainter {
  //圆点的集合
  final List<LedBean> _list;

  //边缘的圆点距离边框的距离
  double borderSpace;

  //高上面的点个数
  double heightNum;

  //宽上面的点个数
  double widthNum;

  var _paint = Paint()
    ..isAntiAlias = true
    ..style = PaintingStyle.fill
    ..color = Color(0xFF3A3A3A);

  LedView(
    this._list, {
    this.borderSpace = 15,
    this.heightNum = 9,
    this.widthNum = 17,
  });

  @override
  void paint(Canvas canvas, Size size) {
    //圆点格子
    _list.forEach((element) {
      canvas.drawCircle(
        element.offset,
        element.r,
        _paint..color = element.color,
      );
    });
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return this != oldDelegate;
  }
}

class LedBean {
  //位置坐标
  final Offset offset;

  //半径
  double r;

  //颜色
  Color color;

  LedBean(this.offset, this.color, {this.r = 5});

  @override
  String toString() {
    return 'LedBean{offset: $offset, r: $r, color: $color}';
  }
}
